#include <QFileDialog>
#include <QString>
#include <QTimer>
#include <QProcess>
#include "mainwindow.h"
#include "ui_mainwindow.h"



MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    ui->progressBar->setRange(0,100);
    ui->progressBar->setValue(0);
    //script=QProcess(this);
    timer = new QTimer(this);
    connect(timer, SIGNAL(timeout()), this, SLOT(pollProcess()));
    ui->statusbar->setText("Valmiina lataamaan!");
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::DialogOpen()
{
    QFileDialog *load = new QFileDialog(this, "Tallenna kansioon..", ".",0);
    load->setFileMode(QFileDialog::Directory);
    load->setConfirmOverwrite(true);
    load->show();

    connect(load, SIGNAL(fileSelected(QString)), this, SLOT(fileSelected(QString)));
}

void MainWindow::fileSelected(const QString &file)
{
    ui->outputfile->setText(file);
    //ui_outputWidget->setText(QString::number(value + ui_inputSpinBox2->value()));
}

void MainWindow::StartProcessing()
{
    ui->pushButton->setDisabled(true);

    QString download;
    //If multiple downloads
    if(ui->url->text().indexOf(";")!=-1)
    {
        multiple=1;
        download=ui->url->text().mid(0, ui->url->text().indexOf(";"));
        ui->url->setText(ui->url->text().mid(ui->url->text().indexOf(";")+1));
    }
    else
    {
        download=ui->url->text();
        multiple=0;
    }
    script.start( "rtmpdump-yle --rtmp rtmp://flashk.yle.fi/AreenaServer --swfUrl http://areena.yle.fi/player/Application.swf?build=1 --timeout 60 --autoResume 5 --pageUrl "+download);
    timer->start(1000);
    ui->statusbar->setText("Ladataan tiedostoa");
    ui->outputfile->setDisabled(true);
}

void MainWindow::pollProcess()
{

     static int progress=1;
     static int totaltime=0;
     QString line;
     QString percent;

      if( script.state()!=0 )
      {
          
            outputstring+=QString( script.readAllStandardError ());


            line="";
            for(int i=0;i<outputstring.length();i++)
            {
                if(outputstring[i]!='\r')
                {
                    line+=outputstring[i];
                }
                else
                {
                    //Download
                  if(progress==1)
                  {
                    bool found=false;
                    bool endfound=false;
                    int end,start;
                    for(int ii=line.length()-1;ii>=0;ii--)
                    {
                        if(line[ii]=='%')
                        {
                            end=ii;
                            found=true;
                        }

                        if(found && line[ii]=='(')
                        {
                            start=ii;
                            endfound=true;
                            break;
                        }

                    }
                    if(endfound)
                    {
                        percent=line.mid(start+1, end-start-1);
                        ui->progressBar->setValue((int)percent.toFloat());
                        //ui->url->setText(percent);
                    }

                    //ui->url->setText(line);

                    int indexi=outputstring.indexOf("Saving to", 0, Qt::CaseInsensitive);
                    if(indexi!=-1)
                    {
                        filename=outputstring.mid(indexi+10,outputstring.indexOf("\n", indexi)-3-(indexi+10));
                        //filename+="mp4";
                        //ui->textEdit->setText(filename);
                    }



                    line="";
                    outputstring.remove(0, i);
                    timer->start(1000);
                   }
                  //ffmpeg..
                  else
                  {
                        QString temppi;
                        int hour,min,sec,msec;
                        int indexi=line.indexOf("Duration: ");
                        if(indexi!=-1)
                        {
                            temppi=QString(line[indexi+10])+QString(line[indexi+11]);
                            hour=temppi.toInt();
                            temppi=QString(line[indexi+13])+QString(line[indexi+14]);
                            min=temppi.toInt();
                            temppi=QString(line[indexi+16])+QString(line[indexi+17]);
                            sec=temppi.toInt();
                            totaltime=hour*60*60+min*60+sec;
                        }

                        indexi=line.indexOf("time=");
                        if(indexi!=-1)
                        {
                            temppi="";
                            for(int ii=indexi+5;ii<line.length();ii++)
                            {
                                if(line[ii]==' ') break;
                                temppi+=QString(line[ii]);
                            }
                            ui->progressBar->setValue((int)((temppi.toFloat()/totaltime)*100));

                        }
                        timer->start(200);
                    }
                }
            }

      }
      else
      {
        outputstring+=QString( script.readAllStandardError ());

        //if Error
        int indexi=outputstring.indexOf("ERROR");
        if(indexi!=-1)
        {
            ui->statusbar->setText(outputstring.mid(indexi) );
            ui->pushButton->setDisabled(false);
            ui->outputfile->setDisabled(false);
            ui->progressBar->setValue(100);
            progress=1;
            timer->stop();
            return;
        }


          if(progress==1)
          {
            progress++;
            if(ui->checkBox->checkState()==Qt::Checked)
            {
                script.start("ffmpeg -y -vcodec copy -acodec copy -i \""+filename+"flv\" \""+ui->outputfile->text()+((ui->outputfile->text().length()==0)?"":"/")+filename+"mp4\"");
                ui->statusbar->setText("Tiedosto ladattu, ksitelln..");
                ui->progressBar->setValue(0);
            }
            else
            {
                //Copy file to a new location if no processing is done
                QFile::copy(filename+"flv.", ui->outputfile->text()+((ui->outputfile->text().length()==0)?"":"/")+filename+"mp4");
            }
          }
          else
          {
              if(multiple)
              {
                  QFile::remove(filename+"flv");
                  timer->stop();
                  progress=1;
                  StartProcessing();
              }
              else
              {
                ui->pushButton->setDisabled(false);
                ui->outputfile->setDisabled(false);
                ui->statusbar->setText("Tiedosto onnistuneesti tallennettu!");
                ui->progressBar->setValue(100);
                QFile::remove(filename+"flv");
                timer->stop();
                progress=1;
              }
          }

      }
}


void MainWindow::startSearch()
{
    search = new searchWindow(this,ui->searchword->text(), ui->url);
    search->show();
}
